'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generate = exports.traverse = undefined;
exports.transform = transform;

var _h2xParse = require('h2x-parse');

var _h2xParse2 = _interopRequireDefault(_h2xParse);

var _h2xGenerate = require('h2x-generate');

var _h2xGenerate2 = _interopRequireDefault(_h2xGenerate);

var _h2xTraverse = require('h2x-traverse');

var _h2xTraverse2 = _interopRequireDefault(_h2xTraverse);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const reduceVisitors = (visitors, opts) => {
  Object.entries(visitors).forEach(([key, visitor]) => {
    if (typeof visitor === 'function') {
      opts[key] = opts[key] || [];
      opts[key].push(visitor);
    } else {
      opts[key] = opts[key] || {};
      reduceVisitors(visitor, opts[key]);
    }
    return opts;
  });
}; /* eslint-disable no-restricted-syntax */


const mergePlugins = plugins => plugins.reduce((opts, plugin) => {
  const { visitor = {}, generator = {} } = plugin();
  reduceVisitors(visitor, opts.visitor);
  reduceVisitors(generator, opts.generator);
  return opts;
}, { visitor: {}, generator: {} });

exports.traverse = _h2xTraverse2.default;
exports.generate = _h2xGenerate2.default;
function transform(code, { plugins = [] } = {}) {
  const ast = (0, _h2xParse2.default)(code);
  const { visitor, generator } = mergePlugins(plugins);
  (0, _h2xTraverse2.default)(ast, visitor);
  return (0, _h2xGenerate2.default)(ast, generator);
}